unit Main;
////////////////////////////////////////////////////////////////////////////////
//      DLL  PR-P18
//  :           1.0
//  :
//  :             24.01.2020 
//  :        32 
////////////////////////////////////////////////////////////////////////////////

                        interface
////////////////////////////////////////////////////////////////////////////////
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, Registry, ExtCtrls, Grids, Menus,
  Spin, Math, Mask, Vcl.ActnList, System.Actions, Vcl.StdActns; //, ToolEdit;

type
  TfrmMain = class(TForm)
    sbrStatus: TStatusBar;
    pgcReaderCommands: TPageControl;
    tbsCommonCommands: TTabSheet;
    grbRS232: TGroupBox;
    btnStartCOM: TBitBtn;
    MainMenu: TMainMenu;
    miFile: TMenuItem;
    miFileExit: TMenuItem;
    miHelp: TMenuItem;
    miHelpAbout: TMenuItem;
    cbxInterfaces: TComboBox;
    btnRefresh: TBitBtn;
    sedByteCount: TSpinEdit;
    btnTest: TBitBtn;
    alActions: TActionList;
    actRefreshPorts: TAction;
    actOpenPort: TAction;
    actClosePort: TAction;
    actTestExchange: TAction;
    btnStopCom: TBitBtn;
    actBeepBlink: TAction;
    GroupBox4: TGroupBox;
    btnDoBeepBlink: TBitBtn;
    sedBeepTime: TSpinEdit;
    cbxUseBeeper: TCheckBox;
    cbxUseLed: TCheckBox;
    GroupBox5: TGroupBox;
    rgrRfFieldControl: TRadioGroup;
    btnFieldControl: TBitBtn;
    actRfFieldControl: TAction;
    actActivateA3: TAction;
    GroupBox7: TGroupBox;
    btnActivateA3: TBitBtn;
    edtCardAUid: TEdit;
    Label28: TLabel;
    Label33: TLabel;
    edtCardSak: TEdit;
    cbxMoreCardsAvail: TCheckBox;
    actActivateA4: TAction;
    GroupBox8: TGroupBox;
    Label34: TLabel;
    Label35: TLabel;
    btnActivateCard4: TBitBtn;
    edtCardAUid4: TEdit;
    edtCardSak4: TEdit;
    cbxMoreCardsAvail4: TCheckBox;
    cbxUsePPS: TCheckBox;
    Bevel1: TBevel;
    Label36: TLabel;
    edtATS: TEdit;
    cbxCidEnabled: TCheckBox;
    edtCID: TEdit;
    edtFsdi: TEdit;
    edtFsci: TEdit;
    Label37: TLabel;
    Label38: TLabel;
    actReaderSoftReset: TAction;
    btnSoftReset: TBitBtn;
    FileExit1: TFileExit;
    edtCardAtqa: TEdit;
    Label53: TLabel;
    Label54: TLabel;
    edtCardAtqa4: TEdit;
    grbE2KeyWrite: TGroupBox;
    Label11: TLabel;
    Bevel2: TBevel;
    Label13: TLabel;
    Label90: TLabel;
    lblBlockBySector: TLabel;
    btnStoreKeyE2: TBitBtn;
    brnAuten: TBitBtn;
    edtUncoded: TEdit;
    rgrUseKey: TRadioGroup;
    btnAuthE2: TBitBtn;
    sedKeySector: TSpinEdit;
    rgrKeyType: TRadioGroup;
    grbMifareSector: TGroupBox;
    Label3: TLabel;
    Label2: TLabel;
    Label14: TLabel;
    edtBlockValue: TEdit;
    sedBlockNr: TSpinEdit;
    btnReadBlock: TBitBtn;
    btnWriteBlock: TBitBtn;
    edtASCII: TEdit;
    btnConvert: TBitBtn;
    actReadMfcBlock: TAction;
    actWriteMfcBlock: TAction;
    actAutenicate: TAction;
    actAutentE2: TAction;
    actStoreKeyE2: TAction;
    actConvertBlockData: TAction;
    actHelpAbout: TAction;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FindPorts();
    //
    procedure FormShow(Sender: TObject);
    procedure actRefreshPortsExecute(Sender: TObject);
    procedure actOpenPortExecute(Sender: TObject);
    procedure actClosePortExecute(Sender: TObject);
    procedure actTestExchangeExecute(Sender: TObject);
    procedure actOpenPortUpdate(Sender: TObject);
    procedure actClosePortUpdate(Sender: TObject);
    procedure actBeepBlinkExecute(Sender: TObject);
    procedure actRfFieldControlExecute(Sender: TObject);
    procedure actActivateA3Execute(Sender: TObject);
    procedure actActivateA4Execute(Sender: TObject);
    procedure edtReadWriteDataKeyPress(Sender: TObject; var Key: Char);
    procedure actReaderSoftResetExecute(Sender: TObject);
    procedure SetCurrentKey();
    procedure rgrUseKeyClick(Sender: TObject);
    procedure actReadMfcBlockExecute(Sender: TObject);
    procedure actWriteMfcBlockExecute(Sender: TObject);
    procedure actAutenicateExecute(Sender: TObject);
    procedure actAutentE2Execute(Sender: TObject);
    procedure actStoreKeyE2Execute(Sender: TObject);
    procedure actConvertBlockDataExecute(Sender: TObject);
    procedure edtBlockValueKeyPress(Sender: TObject; var Key: Char);
    procedure edtBlockValueExit(Sender: TObject);
    procedure actHelpAboutExecute(Sender: TObject);
  private
    res: integer;
    fCurrentReader: integer;
    //ReadersCount: integer;
    function ShowStatus(code: integer): integer;
  public
    //hComm: dword;
    //PortOpened: boolean;
  end;

var
  frmMain: TfrmMain;

                            implementation
////////////////////////////////////////////////////////////////////////////////
{$R *.DFM}
uses
  StrUtils,
  PRP18_h,
  About,
  Errors,
  ErrMessages,
  Utils;

const
  MaxFrameSizesB: array[0..8] of integer = (
    16, 24, 32, 40, 48, 64, 96, 128, 256
    );
  DoPoling: boolean = false;

const
  UncodedKeyADef = 'A0A1A2A3A4A5';
  UncodedKeyBDef = 'B0B1B2B3B4B5';
  UncodedKeysFF  = 'FFFFFFFFFFFF';
  UncodedParsecA = '2FF3B9A696EE';
  UncodedParsecB = 'C364B78A4EAF';

type
  TUncodedKey  = array[0..5] of byte;
  TCodedKey    = array[0..11] of byte;
  PUncodedKey  = ^TUncodedKey;
  PCodedKey    = ^TCodedKey;
const
  DEF_KEY_FF: TUncodedKey = ($FF, $FF, $FF, $FF, $FF, $FF);

var
  UncodedKey: TUncodedKey;
  // Need be global for autentication
  temp_uidlen: uint8;
  temp_uid: array[0..9] of uint8;


////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  //PortOpened := false;
  fCurrentReader := -1;
  //   
  //PortInterf := TInterfList.Create;
  FindPorts();
  //
  sbrStatus.Panels[0].Text := 'Port closed';
  sbrStatus.Panels[3].Text := 'Status: ' + ' unknown';
  //
  pgcReaderCommands.ActivePage := tbsCommonCommands;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  if fCurrentReader >= 0 then
    CloseByNum(fCurrentReader) ;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.FormShow(Sender: TObject);
begin
  rgrUseKeyClick(self);
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.actHelpAboutExecute(Sender: TObject);
begin
  frmAbout.ShowModal
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.SetCurrentKey();
var
  SourceKey, ss: ansistring;
  i: integer;
begin
  // Get key from edit
  SourceKey := edtUncoded.Text;
  while length(SourceKey) < 12 do
    SourceKey := SourceKey + '0';
  for I := 1 to 6 do
  begin
    Ss := Copy(SourceKey, (1 + (I-1)*2), 2);
    UncodedKey[I - 1] := byte(StrToInt('$0' + Ss));
  end;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.rgrUseKeyClick(Sender: TObject);
begin
  case rgrUseKey.ItemIndex of
    0: edtUncoded.Text := UncodedKeyADef;
    1: edtUncoded.Text := UncodedKeyBDef;
    2: edtUncoded.Text := UncodedKeysFF;
  else
    edtUncoded.Text := '';
  end;
  // Convert text to key array
  SetCurrentKey();
end;

////////////////////////////////////////////////////////////////////////////////
//                
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.FindPorts();
const
  desclen = 64;
var
  Ports: TStringList;
  count: integer;
  descr: array[0..(desclen - 1)] of byte;
  descstr: string;
begin
  cbxInterfaces.Clear;
  Application.ProcessMessages;
  // Try to found PR-P18 readers
  count := Enumerate();
  if (count > 0) then begin
    //  aList    COM 
    Ports := TStringList.Create;
    Ports.Clear;
    //     
    //Ports.Sorted := true;
    FillChar(descr, desclen, 0);
    res := GetFirstReader(@descr, desclen);
    if (res = ERR_RESULT_OK) then begin
      // Find as minimum 1 reader - add it to list
      descstr := StrPas(PAnsiChar(@descr));
      Ports.Add(descstr);
      res := GetNextReader(@descr, desclen);
      while (res = ERR_RESULT_OK) do begin
        descstr := AnsiString(PAnsiString(@descr));
        Ports.Add(descstr);
        FillChar(descr, desclen, 0);
        res := GetNextReader(@descr, desclen);
      end;
      // Copy to combobox
      cbxInterfaces.Items := Ports;
      if (cbxInterfaces.Items.Count > 0) then
        cbxInterfaces.ItemIndex := 0;
      // Now list can be free
      Ports.Free;
    end;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
function TfrmMain.ShowStatus(code: integer): integer;
begin
  // If Timeout - Reopen COM port
  if (code = ERR_COMM_TIMEOUT) then begin
    sleep(100);
    actClosePortExecute(self);
    sleep(100);
    actOpenPortExecute(self);
  end;
  sbrStatus.Panels[3].Text := 'Code=0x' + IntToHex(code, 2) + ' - ' + GetErrorText(code);
  result := code;
end;

//==============================================================================
//
//==============================================================================
procedure TfrmMain.actReaderSoftResetExecute(Sender: TObject);
begin
  res := ShowStatus(ReaderSoftReset());
end;

//==============================================================================
//
//==============================================================================
procedure TfrmMain.actRefreshPortsExecute(Sender: TObject);
begin
  FindPorts();
end;

//==============================================================================
//
//==============================================================================
procedure TfrmMain.actOpenPortExecute(Sender: TObject);
var
  ser: array[0..63] of byte;
begin
  if (cbxInterfaces.Items.Count > 0) then begin
    fCurrentReader := cbxInterfaces.ItemIndex;
    if (OpenByNum(fCurrentReader) = ERR_RESULT_OK) then begin
      sbrStatus.Panels[0].Text := ' ';
      // Get Reader serial and show
      GetReaderSerialStr(fCurrentReader, @ser);
      sbrStatus.Panels[2].Text := 'PR-P18 No.' + StrPas(PAnsiChar(@ser));
    end;
  end else begin
    fCurrentReader := -1;
  end;
end;

//==============================================================================
//
//==============================================================================
procedure TfrmMain.actOpenPortUpdate(Sender: TObject);
begin
  if (Sender is TAction) then
    (Sender as TAction).Enabled := fCurrentReader < 0;
end;

//==============================================================================
//
//==============================================================================
procedure TfrmMain.actClosePortExecute(Sender: TObject);
begin
  if fCurrentReader >= 0 then begin
    CloseByNum(fCurrentReader);
    fCurrentReader := -1;
    sbrStatus.Panels[0].Text := ' ';
    sbrStatus.Panels[2].Text := '';
  end;
end;

//==============================================================================
//
//==============================================================================
procedure TfrmMain.actClosePortUpdate(Sender: TObject);
begin
  if (Sender is TAction) then
    (Sender as TAction).Enabled := (fCurrentReader >= 0);
end;

//==============================================================================
//
//==============================================================================
procedure TfrmMain.actTestExchangeExecute(Sender: TObject);
var
  len: uint16;
  buff: array[0..63] of uint8;
  n: integer;
begin
  len := sedByteCount.Value;
  for n  := 0 to len - 1 do
    buff[n] := n + $40;
  sbrStatus.Panels[3].Text := 'Processing...';
  res := ShowStatus(TestTranceive(len, @buff));
end;

//==============================================================================
//
//==============================================================================
procedure TfrmMain.actBeepBlinkExecute(Sender: TObject);
var
  beep, led: uint8;
begin
  if cbxUseLed.Checked then
    led := 1
  else
    led := 0;
  if cbxUseBeeper.Checked then
    beep := 1
  else
    beep := 0;
  sbrStatus.Panels[3].Text := 'Processing...';
  res := ShowStatus(BeepBlink(led, beep, sedBeepTime.Value));
end;

//==============================================================================
//
//==============================================================================
procedure TfrmMain.actRfFieldControlExecute(Sender: TObject);
begin
  res := ShowStatus(RfFieldControl(rgrRfFieldControl.ItemIndex));
end;

//==============================================================================
//  Activate A level 3 ISO-14443, return UID, SAK, more cards (if any)
//==============================================================================
procedure TfrmMain.actActivateA3Execute(Sender: TObject);
var
  atqa: uint16;
  sak: uint8;
  mca: uint8;
  i: integer;
  s: string;
begin
  edtCardAUid.Text := '';
  edtCardAtqa.Text := '';
  edtCardSak.Text := '';
  cbxMoreCardsAvail.Checked := false;
  // Prepare request. If uidLenIn = 0 - ReqA, else WupA. UidLenIn [0, 4, 7, 10]
  temp_uidlen := 0;
  sbrStatus.Panels[3].Text := 'Processing...';
  res := ShowStatus(ActivateCardA3Ex(temp_uidlen, @temp_uid, atqa, sak, mca));
  if res = ERR_RESULT_OK then begin
    s := '';
    for i := 0 to temp_uidlen - 1 do begin
      s := s + IntToHex(temp_uid[i], 2) + ' ';
    end;
    edtCardAUid.Text := s;
    edtCardAtqa.Text := '0x' + IntToHex(atqa, 4);
    edtCardSak.Text := '0x' + IntToHex(sak, 2);
    cbxMoreCardsAvail.Checked := (mca <> 0);
  end;
end;

//==============================================================================
//  Activate A level 3&4 ISO-14443, return UID, SAK, more cards (if any)
//==============================================================================
procedure TfrmMain.actActivateA4Execute(Sender: TObject);
var
  uidlen: uint8;
  uid: array[0..7] of uint8;
  atqa: uint16;
  sak: uint8;
  mca: uint8;
  i: integer;
  s: string;
  usepps: uint8;
  //
  ats, ciden, cid, fsdi, fsci: uint8;
begin
  edtCardAUid4.Text := '';
  edtCardAtqa4.Text := '';
  edtCardSak4.Text := '';
  cbxMoreCardsAvail4.Checked := false;
  //
  edtATS.Text := '';
  cbxCidEnabled.Checked := false;
  edtCID.Text := '';
  edtFsdi.Text := '';
  edtFsci.Text := '';
  // Prepare request. If uidLenIn = 0 - ReqA, else WupA. UidLenIn [0, 4, 7, 10]
  uidlen := 0;
  usepps := uint8(cbxUsePPS.Checked);
  sbrStatus.Panels[3].Text := 'Processing...';
  uidlen := 0;
  res := ShowStatus(ActivateCardA4Ex(usepps, uidlen, @uid, atqa, sak, mca,
                                   ats, ciden, cid, fsdi, fsci));
  if res = ERR_RESULT_OK then begin
    s := '';
    for i := 0 to uidlen - 1 do begin
      s := s + IntToHex(uid[i], 2) + ' ';
    end;
    edtCardAUid4.Text := s;
    edtCardAtqa4.Text := '0x' + IntToHex(atqa, 4);
    edtCardSak4.Text := '0x' + IntToHex(sak, 2);
    cbxMoreCardsAvail4.Checked := (mca <> 0);
    // Level 4 params
    edtATS.Text := '0x' + IntToHex(ats, 2);
    if cbxUsePPS.Checked then begin
      cbxCidEnabled.Checked := (ciden <> 0);
      edtCID.Text := IntToStr(cid);
      edtFsdi.Text := IntToStr(fsdi);
      edtFsci.Text := IntToStr(fsci);
    end;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.edtBlockValueExit(Sender: TObject);
var
  Ts: string;
begin
  Ts := HexStrToASCIIStr(edtBlockValue.Text);
  edtASCII.Text := HexStrToBinStr(edtBlockValue.Text);
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.edtBlockValueKeyPress(Sender: TObject; var Key: Char);
var
  L: integer;
begin
  if Key < ' ' then
    exit;
  Key := UpCase(Key);
  if Key in ['0'..'9', 'A'..'F'] then
  begin
    L := length(edtBlockValue.Text);
    if (((L + 1) mod 3) = 0) and (L > 1) then
    begin
      edtBlockValue.Text := edtBlockValue.Text + ' ';
      edtBlockValue.SelStart := length(edtBlockValue.Text);
    end;
  end else
    Key := #0;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.edtReadWriteDataKeyPress(Sender: TObject; var Key: Char);
begin
  Key := UpCase(Key);
  if ((Key >= #$20) and (not CharInSet(Key, ['0'..'9', 'A'..'F']))) then
    Key := #$0;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.actReadMfcBlockExecute(Sender: TObject);
var
  res: integer;
  blockdata: array[0..MIF_BLOCK_SIZE - 1] of uint8;
  Tc: char;
  Ts: string;
  i: integer;
begin
  // function MfcReadBlock(block: uint16; pBlockData: pbytearray): uint16; cdecl; external DLL_NAME;
  FillChar(blockdata, SizeOf(blockdata), 0);
  sbrStatus.Panels[3].Text := 'Processing...';
  res := ShowStatus(MfcReadBlock(sedBlockNr.Value, @blockdata));
  if res = ERR_RESULT_OK then begin
    edtBlockValue.Text := '';
    Ts := '';
    for I := 0 to SizeOf(blockdata) - 1 do
    begin
      edtBlockValue.Text := edtBlockValue.Text + IntToHex(blockdata[I], 2) + ' ';
      Tc := char(blockdata[I]);
      if Tc < ' ' then
        Ts := Ts + '.'
      else
        Ts := Ts + Tc;
    end;
    edtASCII.Text := Ts;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.actWriteMfcBlockExecute(Sender: TObject);
var
  Ts: ansistring;
  blockdata: array[0..MIF_BLOCK_SIZE - 1] of uint8;
begin
  //    :
  Ts := HexStrToBinStr(ansistring(edtBlockValue.Text));
  if length(Ts) <> 16 then
    SetLength(Ts, 16);
  Move(Ts[1], blockdata, 16);
  sbrStatus.Panels[3].Text := 'Processing...';
  ShowStatus(MfcWriteBlock(sedBlockNr.Value, @blockdata));
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.actConvertBlockDataExecute(Sender: TObject);
var
  I: integer;
  L: integer;
begin
  L := length(edtASCII.Text);
  edtBlockValue.Text := '';
  for I := 1 to L do
  begin
    edtBlockValue.Text := edtBlockValue.Text + IntToHex(ord(edtASCII.Text[I]), 2) + ' ';
  end;
  //  :
  for I := L + 1 to 16 do
    edtBlockValue.Text := edtBlockValue.Text + '00 ';
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.actAutenicateExecute(Sender: TObject);
var
  keytp: uint8;
  block: uint8;
  ptr: pointer;
begin
  if rgrKeyType.ItemIndex = 0 then
    keytp := PHHAL_HW_MFC_KEYA
  else
    keytp := PHHAL_HW_MFC_KEYB;
  block := SectorToBlock4k(sedKeySector.Value);
  if temp_uidlen = 4 then
    ptr := @temp_uid
  else
    ptr := @temp_uid[3];

  sbrStatus.Panels[3].Text := 'Processing...';
  res := ShowStatus(MfcAuthenticateKey(block, keytp, ptr, @UncodedKey));
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.actAutentE2Execute(Sender: TObject);
var
  keytp: uint8;
  block: uint8;
  keyno: uint8;
  res: integer;
  ptr: pointer;
begin
  if rgrKeyType.ItemIndex = 0 then
    keytp := PHHAL_HW_MFC_KEYA
  else
    keytp := PHHAL_HW_MFC_KEYB;
  //
  if temp_uidlen = 4 then
    ptr := @temp_uid
  else
    ptr := @temp_uid[3];
  //
  keyno := sedKeySector.Value * 2 + rgrKeyType.ItemIndex;
  //
  block := sedBlockNr.Value;
  sbrStatus.Panels[3].Text := 'Processing...';
  res := ShowStatus(MfcAuthentKeyNo(block, keytp, ptr, keyno, 0));
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.actStoreKeyE2Execute(Sender: TObject);
var
  keyno: uint8;
begin
  // Determine key number in EE:  00 - key A sector 0, 01 - key B sector 0,
  //                              02 - key A sector 1, 03 - key B sector 1,
  keyno := sedKeySector.Value * 2 + rgrKeyType.ItemIndex;
  sbrStatus.Panels[3].Text := 'Processing...';
  // Call DLL function
  ShowStatus(MfcStoreKeyE2(keyno, 1, @UncodedKey));
end;


end.

